package de.gefa.rewrite;

import java.io.Serializable;

import javax.enterprise.context.SessionScoped;
import javax.inject.Named;

import org.ocpsoft.rewrite.annotation.Parameter;
import org.ocpsoft.rewrite.annotation.RequestAction;
import org.ocpsoft.rewrite.faces.annotation.Deferred;

@Named("customerBean")
@SessionScoped
//@Join(path = "/customer", to = "/faces/customer.xhtml")
public class CustomerBean implements Serializable {

	private static final long serialVersionUID = -1522682558529300364L;

	// in reality, we would have an EJB here
	private final CustomerService customerService = new CustomerService();

	@Parameter("customerId")
	private String customerId;

	private Customer customer;

	public String openCustomer() {
		refreshCustomer();

		return "/customer.xhtml?customerId=" + customerId + "&faces-redirect=true";

	}

	// public Navigate openCustomer() {
	// refreshCustomer();
	// return Navigate.to(CustomerBean.class).with("customerId", customerId);
	// }

	@RequestAction
	@Deferred
	public void init()
	{
		refreshCustomer();
	}

	public String getCustomerId() {
		return customerId;
	}

	public void setCustomerId(String customerId) {
		this.customerId = customerId;
	}

	private void refreshCustomer() {
		if (customerId != null) {
			if (customer == null || (customer != null && !customerId.equals("" + customer.getId()))) {
				customer = customerService.loadCustomer();
			}
		}

	}

}
