package de.gefa.rewrite;

import javax.servlet.ServletContext;

import org.ocpsoft.rewrite.config.Configuration;
import org.ocpsoft.rewrite.config.ConfigurationBuilder;
import org.ocpsoft.rewrite.servlet.config.HttpConfigurationProvider;
import org.ocpsoft.rewrite.servlet.config.Path;
import org.ocpsoft.rewrite.servlet.config.Redirect;
import org.ocpsoft.rewrite.servlet.config.rule.Join;

public class RewriteConfig extends HttpConfigurationProvider {

	@Override
	public Configuration getConfiguration(ServletContext context) {
		return ConfigurationBuilder.begin()

				
				.addRule()
				.when(Path.matches("/"))
				.perform(Redirect.temporary(context.getContextPath() + "/home"))

				.addRule(Join.path("/home").to("/faces/home.xhtml"))
				
				//order not working
//				.addRule(Join.path("/customer").to("/faces/customer.xhtml"))
//				.addRule(Join.path("/customer/{customerId}").to("/faces/customer.xhtml"))
				
				//order working
				.addRule(Join.path("/customer/{customerId}").to("/faces/customer.xhtml"))
				.addRule(Join.path("/customer").to("/faces/customer.xhtml"))
				

		;
	}

	@Override
	public int priority() {
		// TODO Auto-generated method stub
		return 10;
	}

}
